require "product_home_template/version"
#This class provides the template method of providing the output to show products by ranking, click history and general method.
class BasicWay
    #this method initializes the hash array with a specific store details.
    def initialize(param)
       @store_detail = StoreDetail.find(param)
    end
    
    #this method provides the products array with pagination type
    def with_page(pages)
        my_special_method(pages)
    end
    
    #this method provides the products array without pagination type
    def without_page(member)
        my_special_method_without(member)
    end
    
    #this method to run the logic of sorting the products with pagination
    def my_special_method(pages)
        puts("triggered in abstract")
    end
    
    #this method to run the logic of sorting the products with pagination
    def my_special_method_without(member)
        puts("triggered in abstract")
    end

end

#this class provides the functionality to inherit the base class to provide the products by ranking highest selling product.
class CheckByHit < BasicWay
    #this method initializes base class object with the store detail
    def initialize(param)
        super(param)
    end
    
    #this method to run the logic of sorting the products with pagination by ranking the hit
    def my_special_method(pages)
        @product_by_hits = @store_detail.products.order('hit asc').paginate(page: pages, per_page: 3).take(3)
        puts("===== by hit =====")
        puts(@product_by_hits)
        return @product_by_hits
    end
    
    #this method to run the logic of sorting the products without pagination by ranking the hit
    def my_special_method_without(member)
        @product_by_hits = @store_detail.products.order('hit asc').take(3)
        return @product_by_hits
    end
end

class CheckByRank < BasicWay
    #this method initializes base class object with the store detail and an empty array to store the products by click history
    def initialize(param)
        super(param)
        @record_products = []
    end
    
    #this method to run the logic of sorting the products with pagination by ranking the click history
    def my_special_method(pages)
        @sorted_click = current_member.clicks.order('id desc').select("product_identity").group_by{|o| o.product_identity}.keys.uniq
        @sorted_click.each do |c|
            if(@store_detail.products.find_by(id: c))
            @record_products << @store_detail.products.find(c).paginate(page: pages, per_page: 3).find(c)
            end
        end
        @record_products.take(3)
    end
    
    #this method to run the logic of sorting the products without pagination by ranking the click history
    def my_special_method_without(member)
        @sorted_click = member.clicks.order('id desc').select("product_identity").group_by{|o| o.product_identity}.keys.uniq
        @sorted_click.each do |c|
            if(@store_detail.products.find_by(id: c))
            @record_products << @store_detail.products.find(c)
            end
        end
        puts("=== by rank ===")
        puts(@record_products)
        return @record_products.take(3)
    end

end

#this class provides the funcationality of listing all the products available for that particular store
class CheckByNormal < BasicWay
    
    #this method initializes base class object with the store detail 
    def initialize(param)
        super(param)
    end
    
    #this method to run the logic of listing the products with pagination 
    def my_special_method(pages)
        @products = @store_detail.products.order('id asc').paginate(page: pages, per_page: 3)
        puts("=== by baisc page ===")
        return @products
    end
    
    #this method to run the logic of listing the products without pagination 
    def my_special_method_without(member)
        @products = @store_detail.products.order('id asc')
        return @products
    end
end